> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-framework/modularity/jwt/reference/built-in-functions/jwtgeneratekeypair.md).

# JWTGenerateKeyPair

Generates an asymmetric key pair appropriate for the given JWS algorithm. Returns a struct with `privateKey` and `publicKey` as PEM-encoded strings.

## Method Signature

```
JWTGenerateKeyPair( [algorithm] )
```

### Arguments

| Argument    | Type     | Required | Description                                     | Default |
| ----------- | -------- | -------- | ----------------------------------------------- | ------- |
| `algorithm` | `string` | No       | Target algorithm. Determines key type and size. | `RS256` |

### Supported Algorithms

| Algorithm         | Key Type   | Key Size |
| ----------------- | ---------- | -------- |
| `RS256` / `RS384` | RSA        | 2048-bit |
| `RS512`           | RSA        | 4096-bit |
| `ES256`           | EC (P-256) | —        |
| `ES384`           | EC (P-384) | —        |
| `ES512`           | EC (P-521) | —        |

### Returns

A `struct` with:

* `privateKey` — PEM string
* `publicKey` — PEM string

## Examples

```javascript
rsaKeys = jwtGenerateKeyPair( "RS256" );
token   = jwtCreate( { sub: "u1" }, rsaKeys.privateKey, "RS256" );
payload = jwtVerify( token, rsaKeys.publicKey, "RS256" );

ecKeys  = jwtGenerateKeyPair( "ES256" );
token   = jwtCreate( { sub: "u1" }, ecKeys.privateKey, "ES256" );
payload = jwtVerify( token, ecKeys.publicKey, "ES256" );

// Persist keys for production
fileWrite( "/etc/keys/private.pem", rsaKeys.privateKey );
fileWrite( "/etc/keys/public.pem",  rsaKeys.publicKey  );
```

## Related

* [JWTGenerateSecret()](/boxlang-framework/modularity/jwt/reference/built-in-functions/jwtgeneratesecret.md) — symmetric HMAC secret
* [Key Management Guide](/boxlang-framework/modularity/jwt/key-management.md)
* [Algorithms](/boxlang-framework/modularity/jwt/reference/algorithms.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-framework/modularity/jwt/reference/built-in-functions/jwtgeneratekeypair.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
